//complement v1

Level.Particletick=[];
Entity.custom=[];
Entity.All=[];
Entity.lance=[];


Level.roundParticle=function(part,x,y,z,diameter,velX,velY,velZ,color){
	diameter = diameter/2;
	if(!velX){velX=0;}
	if(!velY){velY=0;}
	if(!velZ){velZ=0;}
	if(!color){color=1;}
	for(var i=0;i<2*(Math.PI*diameter);i = i + 0.1){
	Level.addParticle(part,x+0.5+Math.sin(i)*diameter,y,z+0.5+Math.cos(i)*diameter,velX,velY,velZ,color)
	}
};
Level.setAmountParticle=function(part,x,y,z,velX,velY,velZ,count){
	for(var i=0;i<count;i++){
		Level.addParticle(part,x,y,z,velX,velY,velZ);
	}
};
Level.getDistance=function(x,y,z,x1,y1,z1){
	var xDistance = x - x1;
	var yDistance = y - y1;
	var zDistance = z - z1;
	var Distance = Math.sqrt(Math.pow(xDistance,2)+Math.pow(yDistance,2)+Math.pow(zDistance,2))
	return Distance;
};
Level.setHighSpiralParticle=function(part,x,y,z,diameter,height,velX,velY,velZ){
	diameter = diameter/2
	if(!velX){velX=0;}
	if(!velY){velY=0;}
	if(!velZ){velZ=0;}
	for(var i=0;i<height*2;i = i + 0.05){
		Level.addParticle(part,x+0.5+Math.sin(i)*diameter,y+(i/2),z+0.5+Math.cos(i)*diameter,velX,velY,velZ)
	}
};	
Level.setLineParticle=function(part,x,y,z,X,Y,Z,step,velX,velY,velZ){
	if(!part){part=ParticleType.flame;}
	if(!velX){velX=0;}
	if(!velY){velY=0;}
	if(!velZ){velZ=0;}
	if(!step){step=0.1;}
	var xDistance=X-x;
	var yDistance=Y-y;
	var zDistance=Z-z;
	var distance=Math.sqrt(xDistance*xDistance+yDistance*yDistance+zDistance*zDistance)
	xDistance /= distance;
	yDistance /= distance;
	zDistance /= distance;
	for(var i=0;i<distance;i+=step){
		var X=x+xDistance*i;
		var Y=y+yDistance*i;
		var Z=z+zDistance*i
		Level.addParticle(part,X,Y,Z,velX,velY,velZ);
	} 	
};	


Level.setSpiralParticle=function(part,x,y,z,diameter,velX,velY,velZ){
	diameter=diameter/2;
	if(!velX){velX=0;}
	if(!velY){velY=0;}
	if(!velZ){velZ=0;}
	var rad=diameter;
	for(var i=0;i<Math.PI*(Math.PI*rad);i = i + 0.1){
		Level.addParticle(part,x+0.5+Math.sin(i)*diameter,y+0.1,z+0.5+Math.cos(i)*diameter,velX,velY,velZ);
		diameter-=0.01;
	}
};
Level.setFrameParticle=function(part,x,y,z,step,velX,velY,velZ){
	if(!velX){velX=0;}
	if(!velY){velY=0;}
	if(!velZ){velZ=0;}
	if(!part){part=ParticleType.flame;}
	if(!step){step=0.1;}
	for(var i=0;i<1;i+= step){
		Level.addParticle(part,x,y+i,z,velX,velY,velZ);
		Level.addParticle(part,x,y+i,z+1,velX,velY,velZ);
		Level.addParticle(part,x+1,y+i,z,velX,velY,velZ);
		Level.addParticle(part,x+1,y+i,z+1,velX,velY,velZ);
		Level.addParticle(part,x+i,y,z,velX,velY,velZ);
		Level.addParticle(part,x,y,z+i,velX,velY,velZ);
		Level.addParticle(part,x+i,y+1,z,velX,velY,velZ);
		Level.addParticle(part,x,y+1,z+i,velX,velY,velZ);
		Level.addParticle(part,x+i,y,z+1,velX,velY,velZ);
		Level.addParticle(part,x+i,y+1,z+1,velX,velY,velZ);
		Level.addParticle(part,x+1,y,z+i,velX,velY,velZ);
		Level.addParticle(part,x+1,y+1,z+i,velX,velY,velZ);
	}
};
Level.setEllipseParticle=function(part,x,y,z,x_diameter,z_diameter,step,velX,velY,velZ){
	x_diameter=x_diameter/2;
	z_diameter=z_diameter/2;
	if(!velX){velX=0;}
	if(!velY){velY=0;}
	if(!velZ){velZ=0;}
	for(var i=0;i<Math.PI*(Math.pow((x_diameter+z_diameter),2));i += 0.05){
		Level.addParticle(part,x+0.5+Math.sin(i)*x_diameter,y+0.1,z+0.5+Math.cos(i)*z_diameter,velX,velY,velZ)
	}	
};


Level.setStarParticle=function(part,x,y,z,size,velX,velY,velZ){
	size=size/2;
	for(var l=0;l<5;l++){
		var abc3=l*6/5*Math.PI;
		var abc4=(l+1)*6/5*Math.PI;
		var xDistance = (x+0.5+Math.sin(abc4)*size)-(x+0.5+Math.sin(abc3)*size);
		var zDistance = (z+0.5+Math.cos(abc4)*size)-(z+0.5+Math.cos(abc3)*size);
		var distance = Math.sqrt(xDistance*xDistance+zDistance*zDistance);
		xDistance/=distance;
		zDistance/=distance;
		for(var i=0;i<distance;i+=0.05){
			var X=(x+0.5+Math.sin(abc3)*size)+xDistance*i;
			var Z=(z+0.5+Math.cos(abc3)*size)+zDistance*i;
			Level.addParticle(part,X,y+0.1,Z,velZ,velY,velZ);
		} 
	}	
	
};

		
Level.setPolygonalFigureParticle=function(part,x,y,z,size,corner,velX,velY,velZ){
	size=size/2;
	for(var l=0;l<corner;l++){
		var abc3=l*2/corner*Math.PI
		var abc4=(l+1)*2/corner*Math.PI
		var xDistance = (x+0.5+Math.sin(abc4)*size)-(x+0.5+Math.sin(abc3)*size);
		var zDistance = (z+0.5+Math.cos(abc4)*size)-(z+0.5+Math.cos(abc3)*size);
		var distance = Math.sqrt(xDistance*xDistance+zDistance*zDistance);
		xDistance/=distance;
		zDistance/=distance;
		for(var i=0;i<distance;i+=0.05){
			var X =(x+0.5+Math.sin(abc3)*size)+xDistance*i;
			var Z =(z+0.5+Math.cos(abc3)*size)+zDistance*i;
			Level.addParticle(part,X,y+0.1,Z,velZ,velY,velZ)
		}	 
	}
}			
			
Level.ParticleExplosion=function(part,x,y,z,power,count){
	if(!count){count=25;}
	if(!power){power=0.3;}
	for(var i = 0; i < count; i++){
		Level.addParticle(part,x+0.5,y+0.5,z+0.5,(Math.random()-0.5)*power,(Math.random()-0.5)*power,(Math.random()-0.5)*power)
	}	
};		
		
Level.setSphereParticle=function(part,x,y,z,diameter){
	diameter=diameter/2;
	var hollowDiameter=diameter-0.25;
	for(var a=-diameter;a<diameter;a+=Math.abs(diameter/10)){
		for(var b=-diameter;b<diameter;b+=Math.abs(diameter/10)){
			for(var c=-diameter;c<diameter;c+=Math.abs(diameter/10)){
				if((a*a)+(b*b)+(c*c)<=(diameter*diameter)&&(a*a)+(b*b)+(c*c)>=(hollowDiameter*hollowDiameter)){
					Level.addParticle(part,a+x+0.5,b+y,c+z+0.5,0,0,0);
				}
			}
		}
	}
};			
			
Level.setCubeParticle=function(part,x,y,z,power){
	if(!power){power=0.1;}
	for(var i = x;i <= x+1;i+=0.2){
		for(var j = y;j <= y+1;j+=0.2){
			for(var k = z;k <= z+1;k+=0.2){
				Level.addParticle(part,x,j,k,-power,0,0);
				Level.addParticle(part,x+1,j,k,power,0,0);
				Level.addParticle(part,i,y,k,0,-power,0);
				Level.addParticle(part,i,y+1,k,0,power,0);
				Level.addParticle(part,i,j,z,0,0,-power);
				Level.addParticle(part,i,j,z+1,0,0,power);
			}
		}
	}
};

Level.spawncustomMob=function(x,y,z,entityType,texture,health,rendertype){
	var mob=Level.spawnMob(x,y,z,entityType,texture);
	Entity.setRenderType(mob,eval(rendertype));
	Entity.setCollisionSize(mob,3,3);
	Entity.setMaxHealth(mob,health);
	Entity.setHealth(mob,health);
	Entity.setExtraData(mob, "complement.api",JSON.stringify({"texture":texture,"rendertype":rendertype}));
	Entity.custom.push(mob);
}
			
Level.ParticleCoords=function(part,x,y,z,type,controllable,diameter,height){
	this.x = x;
	this.y = y;
	this.z = z;
	this.hei = height*(Math.PI*2);
	this.dia = diameter;
	this.a = 0;
	this.type = type;
	this.part = part;
	this.active = false;	
	this.controllable=controllable;
	if(controllable==false){
		var p=((Entity.getPitch(getPlayerEnt())+90)*Math.PI)/180; 
		var y=((Entity.getYaw(getPlayerEnt())+90)*Math.PI)/180; 
		var xx=Math.sin(p)*Math.cos(y); 
		var yy=Math.sin(p)*Math.sin(y); 
		var zz=Math.cos(p);	
		this.velx=xx;
		this.vely=zz;
		this.velz=yy;	
		controllable=true;
	}
};







//////////
//Entity//
//////////



 
Entity.removelHealth=function(entity,health){
	Entity.setHealth(entity, Entity.getHealth(entity)-health);
	if(Entity.getHealth(entity) <= 0){
		Entity.setHealth(entity, 0);
	}
};
Entity.Throwable=function(type,vel){
	var p=((Entity.getPitch(getPlayerEnt())+90)*Math.PI)/180; 
	var y=((Entity.getYaw(getPlayerEnt())+90)*Math.PI)/180; 
	var xx=Math.sin(p)*Math.cos(y)*(2); 
	var yy=Math.sin(p)*Math.sin(y)*(2); 
	var zz=Math.cos(p)*(2);
	var mob=Level.spawnMob(Player.getX()+xx,Player.getY()+zz,Player.getZ()+yy,type);
	setVelX(mob,vel*xx);
	setVelY(mob,vel*zz);
	setVelZ(mob,vel*yy);
};



Entity.customThrowable=function(type,render,vel,attacktype,Customfunction){
	var p=((Entity.getPitch(getPlayerEnt())+90)*Math.PI)/180; 
	var y=((Entity.getYaw(getPlayerEnt())+90)*Math.PI)/180; 
	var xx=Math.sin(p)*Math.cos(y)*(2); 
	var yy=Math.sin(p)*Math.sin(y)*(2); 
	var zz=Math.cos(p)*(2);
	var mob=Level.spawnMob(Player.getX()+xx,Player.getY()+zz,Player.getZ()+yy,type);
	Entity.setRenderType(mob,Item.getCustomThrowableRenderType(render));
	setVelX(mob,vel*xx);
	setVelY(mob,vel*zz);
	setVelZ(mob,vel*yy);
	Entity.lance.push({
		"type":mob,
		"customfunction":Customfunction,
		"attackType":attacktype
	})
};


Entity.isEqual=function(entity1,entity2){
	return Entity.getUniqueId(entity1)===Entity.getUniqueId(entity2);
};
Entity.isNear=function(entity1,entity2,distanceXZ,distanceY){
	if(!(Math.abs(Entity.getX(entity1) - Entity.getX(entity2))<=distanceXZ))
		return false;
	if(!(Math.abs(Entity.getY(entity1) - Entity.getY(entity2))<=distanceY))
		return false;
	if(!(Math.abs(Entity.getZ(entity1) - Entity.getZ(entity2))<=distanceXZ))
		return false;
	return true;
};
Entity.isEntity=function(entity){
	if(Entity.getAll().indexOf(entity)!==-1){
		return true;
	}else{
		return false;
	}
};
Entity.setVectorSpeed=function(entity,velocity){
	var p=((Entity.getPitch(entity)+90)*Math.PI)/180; 
	var y=((Entity.getYaw(entity)+90)*Math.PI)/180; 
	var xx=Math.sin(p)*Math.cos(y)*2; 
	var yy=Math.sin(p)*Math.sin(y)*2; 
	var zz=Math.cos(p)*2;
	setVelX(entity,velocity*xx);
	setVelY(entity,velocity*zz);
	setVelZ(entity,velocity*yy);
};
Entity.flipView=function(entity1,entity2){
	var yaw = ((Math.atan2(Entity.getZ(entity2) - Entity.getZ(entity1), Entity.getX(entity2)-Entity.getX(entity1))*180)/Math.PI)+270;
	var pitch = (((Math.atan2(Math.abs(Math.sqrt(Math.pow(Math.abs(Entity.getX(entity1)-Entity.getX(entity2)),2)+Math.pow(Math.abs(Entity.getZ(entity1)-Entity.getZ(entity2)), 2))), Entity.getY(entity1) -Entity.getY(entity2)) *180)/Math.PI)-90)*-0.5;
	Entity.setRot(entity1,yaw,pitch);	
};



///////
//Item
//////


Item.sword={
	Id:[],
	Obj:[],
}

Item.setSword=function(id,texture,offset,name,maxdamage,attackdamage,customfunction){
	ModPE.setItem(id,texture,offset,name,1);
	Item.setCategory(id, ItemCategory.TOOL, 0);
	Item.setEnchantType(id,EnchantType.weapon, 1);
	Item.setMaxDamage(id,maxdamage);
	Player.addItemCreativeInv(id,1,0);
	Item.sword.Obj.push({attack:attackdamage,Customfunction:customfunction});
	Item.sword.Id.push(id);
	Item.setHandEquipped(id, true);
};
Item.isSword=function(id){
	if(Item.sword.Id.indexOf(id)!==-1){
		return true;
	}else{
		return false;
	}
};

Item.getSword=function(id){
	try{
		return Item.sword.Obj[Item.sword.Id.indexOf(id)];
	}catch(e){
		clientMessage(e.lineNumber)			
	}
};


Item.spent=function(id){
	var pcid = Player.getCarriedItemData();
	if (pcid!==Item.getMaxDamage(id)) {
		Entity.setCarriedItem(getPlayerEnt(),id,1,pcid+1)
	}else if(pcid == Item.getMaxDamage(id)){
		Level.playSound(Player.getX(), Player.getY(), Player.getZ(), "random.break", 2);
		Entity.setCarriedItem(getPlayerEnt(), 0, 0, 0)
	}
};

Item.spentLeftHand=function(id){
	var pcid = Entity.getOffhandSlotData(getPlayerEnt());
	if (pcid!==Item.getMaxDamage(id)) {
		Entity.setOffhandSlot(getPlayerEnt(),id,1,pcid+1)
	}else if(pcid == Item.getMaxDamage(id)){
		Level.playSound(Player.getX(), Player.getY(), Player.getZ(), "random.break", 2);
		Entity.setOffhandSlot(getPlayerEnt(), 0, 0, 0)
	}
};




//modpe
var sound1 = new android.media.MediaPlayer();
var sound2 = new android.media.MediaPlayer();
var sound3 = new android.media.MediaPlayer();
var playingName="";


ModPE.setTitle=function(tittle){
	Level.executeCommand("/title @p title "+tittle+" ",true);
}
ModPE.setSubTitle=function(subtittle){
	Level.executeCommand("/title @p subtitle "+subtittle+" ",true);
}

ModPE.vectorToX=function(y,p){
	return (-1 * Math.sin(y / 180 * Math.PI) * Math.cos(p / 180 * Math.PI));
};
ModPE.vectorToY=function(y,p){
	return (Math.sin(-p / 180 * Math.PI));
};
ModPE.vectorToZ=function(y,p){
	return (Math.cos(y / 180 * Math.PI) * Math.cos(p / 180 * Math.PI));
};




ModPE.playSoundFromFile = function(fileName){
	try{
	if(sound1.isPlaying() == false){
		sound1.reset();
		sound1.setDataSource(new android.os.Environment.getExternalStorageDirectory() + "/games/com.mojang/"+SoundAPI.modName+"/sound/" + fileName);
		sound1.prepare();
		sound1.start();
		return;
	}
	 if(sound2.isPlaying() == false){
		sound2.reset();
		sound2.setDataSource(new android.os.Environment.getExternalStorageDirectory() + "/games/com.mojang/"+SoundAPI.modName+"/sound/" + fileName);
		sound2.prepare();
		sound2.start();
		return;
	}else{
		sound3.reset();
		sound3.setDataSource(new android.os.Environment.getExternalStorageDirectory() + "/games/com.mojang/"+SoundAPI.modName+"/sound/" + fileName);
		sound3.prepare();
		sound3.start();
		return;
	}
	}catch(e){
		clientMessage(e);
	}
}


ModPE.stopSound=function(fileName){
	try
	{
		if(fileName!=playingName){
			sound1.stop();
			sound1.reset();
		}
		
		
	}catch(err)
	{
		ModPE.showTipMessage("music no found!");
		ModPE.log(" Error: " + err);
	}
}



Player.getInventoryItem=function(id){
    for(var i = 9; i < 45; i++){
        if(Player.getInventorySlot(i)==id){
			return true;
		}
	}
	return false;
};

Player.removeItemInventoryCount=function(id,countdismiss){
    for (var i = 9; i < 45; i++) {
        if(Player.getInventorySlot(i)==id){
			  net.zhuoweizhang.mcpelauncher.ScriptManager.nativeSetInventorySlot(i, Player.getInventorySlot(i), Player.getInventorySlotCount(i) - countdismiss, Player.getInventorySlotData(i));
		}	
	}
};


//===========================
//sound api
//===========================
var File={
	deleteFile:function(d) {
		var c = new java.io.File(d);
		if (c.isDirectory()) {
			var a = c.listFiles();
			for (var b in a) {
				File.deleteFile(a[b].getAbsolutePath())
			}
			c["delete"]()
		}
		if (c.isFile()) {
			c["delete"]()
		}
	},
	doesFileExist:function(b) {
		var a = new java.io.File(b);
		return a.exists()
	},
	isEmpty:function(b) {
		var a = new java.io.File(b);
		if (a.length() > 0) {
			return false
		} else {
			return true
		}
	},
	writeByteArrayToFile:function(a, c) {
		var b = new java.io.File(c);
		if (b.exists()) {
			b["delete"]()
		}
		b.getParentFile().mkdirs();
		b.createNewFile();
		var d = new java.io.FileOutputStream(b);
		d.write(a);
		d.close();
		a = null
	},
	writeInputStreamToFile:function(d, f) {
		var c = new java.io.File(f);
		if (c.exists()) {
			c["delete"]()
		}
		c.getParentFile().mkdirs();
		c.createNewFile();
		var a = new java.io.FileOutputStream(c);
		var e = 0;
		var b = java.lang.reflect.Array.newInstance(java.lang.Byte.TYPE, 1024);
		while ((e = d.read(b)) != -1) {
			a.write(b, 0, e)
		}	
		a.close()
	}
};


var SoundAPI={
	modName:"",
	CurrentSound:"",
	volumen:100,
	soundArray:[
	],
	 Install:function(){
		 new java.lang.Thread(new java.lang.Runnable() {
			run: function() {
				File.deleteFile(android.os.Environment.getExternalStorageDirectory() + "/games/com.mojang/"+SoundAPI.modName+"/sound/");
				for (var a in SoundAPI.soundArray) {      
					try {
						if(!java.io.File(android.os.Environment.getExternalStorageDirectory().getPath()+"/games/com.mojang/"+SoundAPI.modName+"/sound/"+ SoundAPI.soundArray[a].fileName).exists()){
						File.writeInputStreamToFile(ModPE.openInputStreamFromTexturePack(SoundAPI.modName+"-Sound/"+ SoundAPI.soundArray[a].fileName), android.os.Environment.getExternalStorageDirectory() + "/games/com.mojang/"+SoundAPI.modName+"/sound/"+ SoundAPI.soundArray[a].fileName)							
						}
					} catch (c) {
						print("error while writing sound to sdcard (1): " + c)
					}
                
				}
			}
		}).start();
	}
}

/*{
		getScreenName:null,
		ctx:com.mojang.minecraftpe.MainActivity.currentMainActivity.get(),
		ToastMessage:function(str){
			PE.Ui.ctx.runOnUiThread(new java.lang.Runnable(){
				run:function(){
					try{						
						var  ToastMess = android.widget.Toast.makeText(PE.Ui.ctx, new android.text.Html.fromHtml(str), 0);
						var Re=BitmapUtils.stretchImage(android.graphics.Bitmap.createScaledBitmap(BitmapUtils.getTrimmed(android.graphics.BitmapFactory.decodeStream(ModPE.openInputStreamFromTexturePack("images/egui/toast.png")), 0, 0, 400,200), dip(8), dip(8), false), dip(2), dip(2),  dip(4),  dip(4), dip(100), dip(50));
						ToastMess.getView().setBackgroundDrawable(new android.graphics.drawable.BitmapDrawable(ModPE.openInputStreamFromTexturePack("images/egui/toast.png")));
						ToastMess.show();
						
					}catch(e){clientMessage("Error: "+e)}
				}
			})
		}
	}
*/
